package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.UserRoleDetail;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDetailSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<UserRoleDetail> selectCond;
	private JSONObject customsearchval;
	public UserRoleDetailSearchFilter(){
		this.page =new Page<UserRoleDetail>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<UserRoleDetail>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_uesrrolename_eq;

	public void setN_uesrrolename_eq(String n_uesrrolename_eq) {
        this.n_uesrrolename_eq = n_uesrrolename_eq;
        if(!StringUtils.isEmpty(this.n_uesrrolename_eq)){
            this.selectCond.eq("uesrrolename", n_uesrrolename_eq);
        }
    }
	private String n_uesrrolename_like;

	public void setN_uesrrolename_like(String n_uesrrolename_like) {
        this.n_uesrrolename_like = n_uesrrolename_like;
        if(!StringUtils.isEmpty(this.n_uesrrolename_like)){
            this.selectCond.like("uesrrolename", n_uesrrolename_like);
        }
    }
	private String n_userobjectid_eq;

	public void setN_userobjectid_eq(String n_userobjectid_eq) {
        this.n_userobjectid_eq = n_userobjectid_eq;
        if(!StringUtils.isEmpty(this.n_userobjectid_eq)){
            this.selectCond.eq("userobjectid", n_userobjectid_eq);
        }
    }
	private String n_userobjectname_eq;

	public void setN_userobjectname_eq(String n_userobjectname_eq) {
        this.n_userobjectname_eq = n_userobjectname_eq;
        if(!StringUtils.isEmpty(this.n_userobjectname_eq)){
            this.selectCond.eq("userobjectname", n_userobjectname_eq);
        }
    }
	private String n_userobjectname_like;

	public void setN_userobjectname_like(String n_userobjectname_like) {
        this.n_userobjectname_like = n_userobjectname_like;
        if(!StringUtils.isEmpty(this.n_userobjectname_like)){
            this.selectCond.like("userobjectname", n_userobjectname_like);
        }
    }
	private String n_userroledetailname_like;

	public void setN_userroledetailname_like(String n_userroledetailname_like) {
        this.n_userroledetailname_like = n_userroledetailname_like;
        if(!StringUtils.isEmpty(this.n_userroledetailname_like)){
            this.selectCond.like("userroledetailname", n_userroledetailname_like);
        }
    }
	private String n_userroleid_eq;

	public void setN_userroleid_eq(String n_userroleid_eq) {
        this.n_userroleid_eq = n_userroleid_eq;
        if(!StringUtils.isEmpty(this.n_userroleid_eq)){
            this.selectCond.eq("userroleid", n_userroleid_eq);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDETAIL_USEROBJECT_USEROBJECTID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userobjectid_eq("NA");
			}
			else{
				this.setN_userobjectid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDETAIL_USERROLE_USERROLEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userroleid_eq("NA");
			}
			else{
				this.setN_userroleid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("userroledetailname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}